
from Interface import Base

class IVirtualHostFolder( Base ):
    """Methods to discover information about the current virtual host
    and convenience methods to determine links and breadcrumbs within
    the given virtual host."""

    def getOriginalRequestURL(REQUEST=None):
        """Get the literal slash-separated string, minus host port and protocol, used in this request"""

    def getCleanOriginalRequestList(REQUEST=None, rootName="/", includeQueryString=0):
        """Returns a list representing a cleaned version of the
        original request combined with breadcrumb links for each
        element.  index_html is removed, and a final element with a
        query string hides the query string in the path element but
        includes it in the URL.  Intended to save time with
        breadcrumbs.  Format is this, for instance:
        [
            [rootName,"/"],
            ["firstPathElement","/firstPathElement"],
            ["lastPathElement","/firstPathElement/lastPathElement?queryString=Hidden"]
        ]
        First element (root) will have name specified by rootName.
        A query string in the last element will be completely removed
        from path and links if includeQueryString==0, and removed only
        in the path (but kept in the final link) if
        includeQueryString==1.  Any other value will keep the query
        string in both the path and the link."""

    def getCanonicalVirtualRootURL():
        """Get the canonical virtual host root URL (string)"""

    def getCanonicalVirtualRootObject(REQUEST=None):
        """Get the canonical virtual host root object"""

    def getActualVirtualRootURL(REQUEST=None):
        """Get the actual virtual host root URL (string); it will be
        the same as the above, unless overwritten by a HostOverride
        object such as an alias."""

    def getActualVirtualRootObject(REQUEST=None):
        """Get the actual virtual host root object, if any"""

    def getCurrentVirtualHostObject(REQUEST=None):
        """returns the current virtual host object, or None. (Note
        that in the current implementation each host can have a
        property sheet, which can be modified using standard Zope
        property sheet interfaces after the current host is obtained
        via this method.  I deemed an overlay interface to modify the
        properties via the virtual host folder to be
        counter-productive, for now.)"""

    def getVirtualHostStatus(REQUEST=None):
        """returns 1 if a virtual host is currently in use, otherwise 0"""
