import re

VirtualHostKeyEmptyMarker="XxXxXxXxXxXx"

isAFolderName=re.compile(r'^[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ][\w_]*$')
cleanPath=re.compile(r'(.+?)/?$')
isUsefulTemplate=re.compile(r'\\(\d|g)')
isIPAddress=re.compile(r'^[\d.]+$')
testURLMatch=re.compile(r'^(\w{3,6}://)?([\w_\.]+)(:\d+)?(/.*)?$')
marker=[]

def getErrorText(e):
    if type(e)==type(""): return [e]
    res=[]
    if hasattr(e,"args") and e.args:
        if e.args==type(""): res.append(e.args)
        else: res.extend(e.args)
    if hasattr(e,"text") and e.text:
        if e.text==type(""): res.append(e.text)
        else: res.extend(e.text)
    return res


class DictMimic: # ah, looking forward to Python 2.2...
    def __init__(self):
        self.dict={}
    def __len__(self):
        return len(self.dict)
    def __getitem__(self, key):
        return self.dict[key]
    def __setitem__(self, key, value):
        self.dict[key]=value
    def __delitem__(self, key):
        del self.dict[key]
    def __contains__(self, obj):
        return obj in self.dict.keys()
    def clear(self):
        self.dict.clear()
    def copy(self):
        newObj=self.__class__()
        newObj.dict=self.dict.copy()
        return newObj
    def has_key(self, k):
        return self.dict.has_key(k)
    def items(self):
        return self.dict.items()
    def keys(self):
        return self.dict.keys()
    def update(self, b):
        self.dict.update(b)
    def values(self):
        return self.dict.values()
    def get(self, k, v=None):
        return self.dict.get(k, v)
    def setdefault(self, k, v=None):
        return self.dict.setdefault(k, v)
    def popitem(self):
        return self.dict.popitem()

class ResponseMimic(DictMimic):
    def redirect(location, lock=0):
        self.dict['FAKE_REDIRECT']=location
    def __init__(self):
        self.dict={}

class RequestMimic(DictMimic):
    def __init__(self):
        self.dict={}
        self.protocol=self.host=self.port=""
        self.RESPONSE=ResponseMimic()
    def setServerURL(self, protocol, host, port="8080"):
        self.dict["BASE0"]=protocol+"://"+host
        self.protocol=protocol
        self.host=host
        self.port=port
    set=DictMimic.__setitem__

isIndex_html=re.compile(r'index_html\W?')
def pathToBreadcrumbs(path, rootName="/", includeQueryString=0):
    """converts path to path plus links.  First element (root) will
    have name specified by rootName.  A query string in the last
    elementwill be completely removed from path and links if
    includeQueryString==false, and removed only in the path (but kept in
    the final link) if includeQueryString==true."""

    #if includeQueryString == 0 and "?" in path[-1]:
    #    path[-1]=path[-1][:path[-1].index("?")]
    ret=[None]*len(path) # optimization I'm trying out: sets up an array of the appropriate length
    for i in range(len(path)):
        ret[i]={"id":path[i], "url":"/"+"/".join(path[1:(i+1)])}
    ret[0]["id"]=rootName
    if isIndex_html.match(ret[-1]["id"]):
        ret[-2]["url"]+="/"+ret[-1]["id"]
        ret.pop()
    if "?" in ret[-1]["id"]:
        ret[-1]["id"]=ret[-1]["id"][:ret[-1]["id"].index("?")]
    if not includeQueryString and "?" in ret[-1]["url"]:
        ret[-1]["url"]=ret[-1]["url"][:ret[-1]["url"].index("?")]
    return ret

